- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Search for |

- File List
- Globals

# udata.h File Reference

C API: Data loading interface. More...

`#include "unicode/utypes.h"`

Go to the source code of this file.

## Data Structures
struct | UDataInfo
| UDataInfo contains the properties about the requested data. More...
## Defines
#define | U_TREE_SEPARATOR '-'
| Character used to separate package names from tree names.
#define | U_TREE_SEPARATOR_STRING "-"
| String used to separate package names from tree names.
#define | U_TREE_ENTRY_SEP_CHAR '/'
| Character used to separate parts of entry names.
#define | U_TREE_ENTRY_SEP_STRING "/"
| String used to separate parts of entry names.
#define | U_ICUDATA_ALIAS "ICUDATA"
| Alias for standard ICU data.
## Typedefs
typedef UDataMemory | UDataMemory
| Forward declaration of the data memory type.
typedef UBool U_CALLCONV | UDataMemoryIsAcceptable (void *context, const char *type, const char *name, const UDataInfo *pInfo)
| Callback function for udata_openChoice().
## Enumerations
enum | UDataFileAccess { UDATA_NO_FILES, UDATA_ONLY_PACKAGES, UDATA_PACKAGES_FIRST, UDATA_FILES_FIRST, UDATA_DEFAULT_ACCESS = UDATA_FILES_FIRST, UDATA_FILE_ACCESS_COUNT }
| Possible settings for udata_setFileAccess(). More...
## Functions
UDataMemory * | udata_open (const char *path, const char *type, const char *name, UErrorCode *pErrorCode)
| Convenience function.
UDataMemory * | udata_openChoice (const char *path, const char *type, const char *name, UDataMemoryIsAcceptable *isAcceptable, void *context, UErrorCode *pErrorCode)
| Data loading function.
void | udata_close (UDataMemory *pData)
| Close the data memory.
const void * | udata_getMemory (UDataMemory *pData)
| Get the pointer to the actual data inside the data memory.
void | udata_getInfo (UDataMemory *pData, UDataInfo *pInfo)
| Get the information from the data memory header.
void | udata_setCommonData (const void *data, UErrorCode *err)
| This function bypasses the normal ICU data loading process and allows you to force ICU's system data to come out of a user-specified area in memory.
void | udata_setAppData (const char *packageName, const void *data, UErrorCode *err)
| This function bypasses the normal ICU data loading process for application-specific data and allows you to force the it to come out of a user-specified pointer.
void | udata_setFileAccess (UDataFileAccess access, UErrorCode *status)
| This function may be called to control how ICU loads data.

## Detailed Description

C API: Data loading interface.

## Information about data loading interface

This API is used to find and efficiently load data for ICU and applications using ICU. It provides an abstract interface that specifies a data type and name to find and load the data. Normally this API is used by other ICU APIs to load required data out of the ICU data library, but it can be used to load data out of other places.

See the User Guide Data Management chapter.

Definition in file udata.h.

## Define Documentation

#define U_ICUDATA_ALIAS "ICUDATA"

Alias for standard ICU data.

Internal:
  Do not use. This API is for interal use only. ICU 3.0

Definition at line 68 of file udata.h.

#define U_TREE_ENTRY_SEP_CHAR '/'

Character used to separate parts of entry names.

Internal:
  Do not use. This API is for interal use only. ICU 3.0

Definition at line 56 of file udata.h.

#define U_TREE_ENTRY_SEP_STRING "/"

String used to separate parts of entry names.

Internal:
  Do not use. This API is for interal use only. ICU 3.0

Definition at line 62 of file udata.h.

#define U_TREE_SEPARATOR '-'

Character used to separate package names from tree names.

Internal:
  Do not use. This API is for interal use only. ICU 3.0

Definition at line 44 of file udata.h.

#define U_TREE_SEPARATOR_STRING "-"

String used to separate package names from tree names.

Internal:
  Do not use. This API is for interal use only. ICU 3.0

Definition at line 50 of file udata.h.

## Typedef Documentation

typedef struct UDataMemory UDataMemory

Forward declaration of the data memory type.

Stable:
  ICU 2.0

Definition at line 150 of file udata.h.

typedef UBool U_CALLCONV UDataMemoryIsAcceptable(void *context, const char *type, const char *name, const UDataInfo *pInfo)

Callback function for udata_openChoice().

Parameters:

  | context | parameter passed into `udata_openChoice()`.
  | type | The type of the data as passed into `udata_openChoice()`. It may be `NULL`.
  | name | The name of the data as passed into `udata_openChoice()`.
  | pInfo | A pointer to the `UDataInfo` structure of data that has been loaded and will be returned by `udata_openChoice()` if this function returns `TRUE`.

Returns:
  TRUE if the current data memory is acceptable

Stable:
  ICU 2.0

Definition at line 166 of file udata.h.

## Enumeration Type Documentation

enum UDataFileAccess

Possible settings for udata_setFileAccess().

See also:
  udata_setFileAccess

Stable:
  ICU 3.4

Enumerator:

  UDATA_NO_FILES | ICU does not access the file system for data loading.
  UDATA_ONLY_PACKAGES | ICU only loads data from packages, not from single files.
  UDATA_PACKAGES_FIRST | ICU loads data from packages first, and only from single files if the data cannot be found in a package.
  UDATA_FILES_FIRST | ICU looks for data in single files first, then in packages. (default)
  UDATA_DEFAULT_ACCESS | An alias for the default access mode.

Definition at line 359 of file udata.h.

## Function Documentation

void udata_close | ( | UDataMemory * | pData | ) |

Close the data memory.

This function must be called to allow the system to release resources associated with this data memory.

Parameters:

  | pData | The pointer to data memory object

Stable:
  ICU 2.0

void udata_getInfo | ( | UDataMemory * | pData,
|  | UDataInfo * | pInfo |
| ) |  |  |

Get the information from the data memory header.

This allows to get access to the header containing platform data properties etc. which is not part of the data itself and can therefore not be accessed via the pointer that `udata_getMemory()` returns.

Parameters:

  | pData | pointer to the data memory object
  | pInfo | pointer to a UDataInfo object; its `size` field must be set correctly, typically to `sizeof(UDataInfo)`.

`*pInfo` will be filled with the UDataInfo structure in the data memory object. If this structure is smaller than `pInfo->size`, then the `size` will be adjusted and only part of the structure will be filled.

Stable:
  ICU 2.0

const void* udata_getMemory | ( | UDataMemory * | pData | ) |

Get the pointer to the actual data inside the data memory.

The data is read-only.

Parameters:

  | pData | The pointer to data memory object

Stable:
  ICU 2.0

UDataMemory* udata_open | ( | const char * | path,
|  | const char * | type,
|  | const char * | name,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Convenience function.

This function works the same as `udata_openChoice` except that any data that matches the type and name is assumed to be acceptable.

Parameters:

  | path | Specifies an absolute path and/or a basename for the finding of the data in the file system. `NULL` for ICU data.
  | type | A string that specifies the type of data to be loaded. For example, resource bundles are loaded with type "res", conversion tables with type "cnv". This may be `NULL` or empty.
  | name | A string that specifies the name of the data.
  | pErrorCode | An ICU UErrorCode parameter. It must not be `NULL`.

Returns:
  A pointer (handle) to a data memory object, or `NULL` if an error occurs. Call `udata_getMemory()` to get a pointer to the actual data.

See also:
  udata_openChoice

Stable:
  ICU 2.0

UDataMemory* udata_openChoice | ( | const char * | path,
|  | const char * | type,
|  | const char * | name,
|  | UDataMemoryIsAcceptable * | isAcceptable,
|  | void * | context,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Data loading function.

This function is used to find and load efficiently data for ICU and applications using ICU. It provides an abstract interface that allows to specify a data type and name to find and load the data.

The implementation depends on platform properties and user preferences and may involve loading shared libraries (DLLs), mapping files into memory, or fopen()/fread() files. It may also involve using static memory or database queries etc. Several or all data items may be combined into one entity (DLL, memory-mappable file).

The data is always preceded by a header that includes a `UDataInfo` structure. The caller's `isAcceptable()` function is called to make sure that the data is useful. It may be called several times if it rejects the data and there is more than one location with data matching the type and name.

If `path==NULL`, then ICU data is loaded. Otherwise, it is separated into a basename and a basename-less directory string. The basename is used as the data package name, and the directory is logically prepended to the ICU data directory string.

For details about ICU data loading see the User Guide Data Management chapter. (http://icu-project.org/userguide/icudata.html)

Parameters:

  | path | Specifies an absolute path and/or a basename for the finding of the data in the file system. `NULL` for ICU data.
  | type | A string that specifies the type of data to be loaded. For example, resource bundles are loaded with type "res", conversion tables with type "cnv". This may be `NULL` or empty.
  | name | A string that specifies the name of the data.
  | isAcceptable | This function is called to verify that loaded data is useful for the client code. If it returns FALSE for all data items, then `udata_openChoice()` will return with an error.
  | context | Arbitrary parameter to be passed into isAcceptable.
  | pErrorCode | An ICU UErrorCode parameter. It must not be `NULL`.

Returns:
  A pointer (handle) to a data memory object, or `NULL` if an error occurs. Call `udata_getMemory()` to get a pointer to the actual data.

Stable:
  ICU 2.0

void udata_setAppData | ( | const char * | packageName,
|  | const void * | data,
|  | UErrorCode * | err |
| ) |  |  |

This function bypasses the normal ICU data loading process for application-specific data and allows you to force the it to come out of a user-specified pointer.

The format of this data is that of the icu common data file, like 'icudt26l.dat' or the corresponding shared library (DLL) file. The application must read in or otherwise construct an image of the data and then pass the address of it to this function.

Warning: setAppData will set a U_USING_DEFAULT_WARNING code if data with the specifed path that has already been opened, or if setAppData with the same path has already been called. Any such calls to setAppData will have no effect.

Parameters:

  | packageName | the package name by which the application will refer to (open) this data
  | data | pointer to the data
  | err | outgoing error status `U_USING_DEFAULT_WARNING, U_UNSUPPORTED_ERROR`

See also:
  udata_setCommonData

Stable:
  ICU 2.0

void udata_setCommonData | ( | const void * | data,
|  | UErrorCode * | err |
| ) |  |  |

This function bypasses the normal ICU data loading process and allows you to force ICU's system data to come out of a user-specified area in memory.

The format of this data is that of the icu common data file, as is generated by the pkgdata tool with mode=common or mode=dll. You can read in a whole common mode file and pass the address to the start of the data, or (with the appropriate link options) pass in the pointer to the data that has been loaded from a dll by the operating system, as shown in this code:

extern const char U_IMPORT U_ICUDATA_ENTRY_POINT []; // U_ICUDATA_ENTRY_POINT is same as entry point specified to pkgdata tool UErrorCode status = U_ZERO_ERROR;

udata_setCommonData(&U_ICUDATA_ENTRY_POINT, &status);

Warning: ICU must NOT have even attempted to access its data yet when this call is made, or U_USING_DEFAULT_WARNING code will be returned. Be careful of UnicodeStrings in static initialization which may attempt to load a converter (use the UNICODE_STRING(x) macro instead).

Also note that it is important that the declaration be as above. The entry point must not be declared as an extern void*.

This function has no effect on application (non ICU) data. See udata_setAppData() for similar functionality for application data.

Parameters:

  | data | pointer to ICU common data
  | err | outgoing error status `U_USING_DEFAULT_WARNING, U_UNSUPPORTED_ERROR`

Stable:
  ICU 2.0

void udata_setFileAccess | ( | UDataFileAccess | access,
|  | UErrorCode * | status |
| ) |  |  |

This function may be called to control how ICU loads data.

It must be called before any ICU data is loaded, including application data loaded with ures/ResourceBundle or udata APIs. It should be called before u_init. This function is not multithread safe. The results of calling it while other threads are loading data are undefined.

Parameters:

  | access | The type of file access to be used
  | status | Error code.

See also:
  UDataFileAccess

Stable:
  ICU 3.4